﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;
using Excel = Microsoft.Office.Interop.Excel;
using System.Collections;

namespace ExcelSDI
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("3162C62B-3209-452A-B38D-D1CA38072B69"), ProgId("ExcelSDI.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private AddinExpress.XL.ADXExcelTaskPanesManager adxExcelTaskPanesManager1;
        private ADXRibbonTab workbookcopierRibbonTab;
        private ADXRibbonGroup adxRibbonGroup1;
        private ADXRibbonButton showTaskPaneRibbonButton;
        private ImageList imlIcons;
        
        internal frmTaskPane taskPaneForm = null;
        
        AddinExpress.XL.ADXExcelTaskPanesCollectionItem taskPaneItem = null;
        private ADXExcelAppEvents adxExcelEvents;

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(AddinModule));
            this.adxExcelTaskPanesManager1 = new AddinExpress.XL.ADXExcelTaskPanesManager(this.components);
            this.workbookcopierRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.adxRibbonGroup1 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.showTaskPaneRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.imlIcons = new System.Windows.Forms.ImageList(this.components);
            this.adxExcelEvents = new AddinExpress.MSO.ADXExcelAppEvents(this.components);
            this.adxExcelTaskPanesManager1.SetOwner(this);
            // 
            // workbookcopierRibbonTab
            // 
            this.workbookcopierRibbonTab.Caption = "WorkBook Copier";
            this.workbookcopierRibbonTab.Controls.Add(this.adxRibbonGroup1);
            this.workbookcopierRibbonTab.Id = "adxRibbonTab_0d5ccfa73e0e4f98ad6c67609d79fc34";
            this.workbookcopierRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // adxRibbonGroup1
            // 
            this.adxRibbonGroup1.Caption = "Workbook Copier";
            this.adxRibbonGroup1.Controls.Add(this.showTaskPaneRibbonButton);
            this.adxRibbonGroup1.Id = "adxRibbonGroup_e1266152300c4b20a45cec99ec386a4f";
            this.adxRibbonGroup1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // showTaskPaneRibbonButton
            // 
            this.showTaskPaneRibbonButton.Caption = "Workbook Copy";
            this.showTaskPaneRibbonButton.Id = "adxRibbonButton_1429862bf353401d9baa8c8298ecfcc6";
            this.showTaskPaneRibbonButton.Image = 0;
            this.showTaskPaneRibbonButton.ImageList = this.imlIcons;
            this.showTaskPaneRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.showTaskPaneRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.showTaskPaneRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.showTaskPaneRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.showTaskPaneRibbonButton_OnClick);
            // 
            // imlIcons
            // 
            this.imlIcons.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imlIcons.ImageStream")));
            this.imlIcons.TransparentColor = System.Drawing.Color.Transparent;
            this.imlIcons.Images.SetKeyName(0, "copy");
            // 
            // adxExcelEvents
            // 
            this.adxExcelEvents.WorkbookNewSheet += new AddinExpress.MSO.ADXExcelWorkbook_EventHandler(this.adxExcelEvents_WorkbookNewSheet);
            this.adxExcelEvents.WindowResize += new AddinExpress.MSO.ADXHostWindow_EventHandler(this.adxExcelEvents_WindowResize);
            // 
            // AddinModule
            // 
            this.AddinName = "ExcelSDI";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaExcel;
            this.AddinStartupComplete += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinStartupComplete);

        }
        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }

        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Excel._Application ExcelApp
        {
            get
            {
                return (HostApplication as Excel._Application);
            }
        }

        private void adxExcelEvents_WorkbookNewSheet(object sender, object workbook, object sheet)
        {

        }

        private void showTaskPaneRibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            if (this.HostMajorVersion > 14)
            {
                if (taskPaneForm == null)
                {
                    taskPaneForm = new frmTaskPane(this.ExcelApp as Excel._Application);
                    taskPaneForm.TopMost = true;
                }
                taskPaneForm.Show();
            }
            else
            {
                AddTaskPane();
                taskPaneItem.ShowTaskPane();
            }
        }

        private bool IsAllWindowsMinimized()
        {
            Excel.Windows windows = ExcelApp.Windows;
            try
            {
                for (int i = 1; i <= windows.Count; i++)
                {
                    Excel.Window wnd = windows[i];
                    try
                    {
                        if (wnd.WindowState != Excel.XlWindowState.xlMinimized)
                            return false;
                    }
                    finally
                    {
                        if (wnd != null)
                            Marshal.ReleaseComObject(wnd);
                    }
                }
            }
            finally
            {
                if (windows != null)
                    Marshal.ReleaseComObject(windows);
            }
            return true;
        }

        private void adxExcelEvents_WindowResize(object sender, object hostObj, object window)
        {
            Excel.Window currentWindow = null;

            try
            {
                currentWindow = (Excel.Window)window;

                if (taskPaneForm != null)
                {
                    if (currentWindow.WindowState == Excel.XlWindowState.xlMinimized)
                    {
                        if (IsAllWindowsMinimized())
                            taskPaneForm.Hide();
                    }
                    else
                    {
                        taskPaneForm.Show();
                    }
                }
            }
            finally
            {
                if (currentWindow != null)
                    Marshal.ReleaseComObject(currentWindow);
            }
        }

        private void AddinModule_AddinStartupComplete(object sender, EventArgs e)
        {
            if (this.HostMajorVersion <= 14)
            {
                AddTaskPane();
            }
        }

        private void AddTaskPane()
        {
            if (adxExcelTaskPanesManager1.Items.Count > 0) return;

            taskPaneItem = new AddinExpress.XL.ADXExcelTaskPanesCollectionItem();
            taskPaneItem.TaskPaneClassName = "ExcelSDI.ADXExcelTaskPane1";
            taskPaneItem.AlwaysShowHeader = true;
            taskPaneItem.UseOfficeThemeForBackground = true;
            taskPaneItem.CloseButton = true;
            taskPaneItem.Position = AddinExpress.XL.ADXExcelTaskPanePosition.Left;
            adxExcelTaskPanesManager1.Items.Add(taskPaneItem);
        }

    }
}

