﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Excel = Microsoft.Office.Interop.Excel;
using System.Runtime.InteropServices;

namespace ExcelSDI
{
    public partial class ctlWBCopier : UserControl
    {
        private Excel._Application ExcelAppObj = null;

        public ctlWBCopier(Excel._Application excelApp)
        {
            ExcelAppObj = excelApp;
            InitializeComponent();
        }

        private void lbWorkbooks_SelectedIndexChanged(object sender, EventArgs e)
        {
            Excel.Application app = null;
            Excel.Workbooks workBooks = null;
            Excel.Workbook workBook = null;
            Excel.Sheets workSheets = null;
            Excel.Worksheet workSheet = null;

            try
            {
                lbWorksheets.Items.Clear();

                app = (Excel.Application)this.ExcelAppObj;
                workBooks = app.Workbooks;

                workBook = workBooks.get_Item(lbWorkbooks.SelectedItem.ToString());
                workSheets = workBook.Sheets;

                for (int i = 1; i <= workSheets.Count; i++)
                {
                    workSheet = workSheets[i] as Excel.Worksheet;
                    lbWorksheets.Items.Add(workSheet.Name);
                    if (workSheet != null)
                        Marshal.ReleaseComObject(workSheet);
                }

            }
            finally
            {
                if (workBooks != null)
                    Marshal.ReleaseComObject(workBooks);
                if (workBook != null)
                    Marshal.ReleaseComObject(workBook);
                if (workSheets != null)
                    Marshal.ReleaseComObject(workSheets);
            }
        }

        private void ctlWBCopier_Load(object sender, EventArgs e)
        {
            LoadWorkBooks();
        }

        private void lblRefresh_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            LoadWorkBooks();
        }

        private void LoadWorkBooks()
        {
            Excel.Application app = null;
            Excel.Workbooks workBooks = null;
            Excel.Workbook workBook = null;

            try
            {
                lbWorkbooks.Items.Clear();
                cboWorkbooks.Items.Clear();

                app = (Excel.Application)this.ExcelAppObj;
                workBooks = app.Workbooks;

                for (int i = 1; i <= workBooks.Count; i++)
                {
                    workBook = workBooks.Item[i];
                    this.lbWorkbooks.Items.Add(workBook.Name);
                    this.cboWorkbooks.Items.Add(workBook.Name);
                }

            }
            finally
            {
                if (workBooks != null)
                    Marshal.ReleaseComObject(workBooks);
                if (workBook != null)
                    Marshal.ReleaseComObject(workBook);
            }
        }

        private void btnCopy_Click(object sender, EventArgs e)
        {
            Excel.Application app = null;
            Excel.Workbooks workBooks = null;
            Excel.Workbook sourceBook = null;
            Excel.Sheets sourceSheets = null;
            Excel.Worksheet sourceSheet = null;

            Excel.Workbook targetBook = null;

            try
            {
                app = (Excel.Application)this.ExcelAppObj;
                workBooks = app.Workbooks;

                sourceBook = workBooks.get_Item(lbWorkbooks.SelectedItem.ToString());
                if (sourceBook != null)
                {
                    sourceSheets = sourceBook.Sheets;
                    sourceSheet = (Excel.Worksheet)sourceSheets.get_Item(lbWorksheets.SelectedItem.ToString());

                    if (sourceSheet != null)
                    {
                        targetBook = workBooks.get_Item(cboWorkbooks.SelectedItem.ToString());
                        if (targetBook != null)
                        {

                            sourceBook.Sheets.Copy(targetBook.Sheets[1]);
                        }
                    }
                }

            }
            finally
            {
                if (workBooks != null)
                    Marshal.ReleaseComObject(workBooks);
            }
        }

    }
}
